//**Start Encode**

//--------------------------------------------------------------
//
// TUpdateInstanceCallback Object
//
//--------------------------------------------------------------
function
TUpdateInstanceCallback( inSource)
{
	// required callbacks

	this.Status_Callback			= TUpdateInstanceCallback_StatusCallback;
	this.Prompt						= TUpdateInstanceCallback_Prompt;
	this.Show_Download_Status		= TUpdateInstanceCallback_ShowDownloadStatus;	
	this.Set_Messages				= TUpdateInstanceCallback_SetMessages;
	this.Begin_File_Download		= TUpdateInstanceCallback_BeginFileDownload;
	this.Set_Download_Progress_Max	= TUpdateInstanceCallback_SetDownloadProgressMax;
	this.Set_Progress				= TUpdateInstanceCallback_SetProgress;
	this.End_File_Download			= TUpdateInstanceCallback_EndFileDownload;
	this.Begin_Wait					= TUpdateInstanceCallback_BeginWait;
	this.End_Wait					= TUpdateInstanceCallback_EndWait;
	this.m_Window					= window; // ??


	// custom methods
	this.SetDebugStatus = TUpdateInstanceCallback_SetDebugStatus;
	this.SetStatusText = TUpdateInstanceCallback_SetStatusText;
	this.SetErrorText = TUpdateInstanceCallback_SetErrorText;
	this.UpdateFileProgress = TUpdateInstanceCallback_UpdateFileProgress;
	this.DisplayUpdateMessage = TUpdateInstanceCallback_UpdateMessage;
	
	this.NotifyUpdateFinished = TUpdateInstanceCallback_NotifyUpdateFinished;
	
	// custom data
	this.m_Src = inSource;
	
	this.m_Successful = false;
	this.m_UpdateCancelled = false;
	this.m_SectionsProcessed = false;
	this.m_DownloadMessage = "";
	this.m_CancelMessage = "";
	this.m_DownloadProgressMax = 0;
	
	this.m_MessageStore = new Array();
	
}
//========================================
function
TUpdateInstanceCallback_SetDebugStatus(inStr)
{
	HandleUpdateDebugStatusText(inStr);

}
//========================================
function
TUpdateInstanceCallback_SetStatusText(inStr)
{

	HandleUpdateStatusText(inStr);
}
//========================================
function
TUpdateInstanceCallback_SetErrorText(inStr)
{

	HandleUpdateErrorText(inStr);	
}
//========================================
function
TUpdateInstanceCallback_UpdateFileProgress(inCur,downloadedBytes, totalBytes, hours, minutes, seconds)
{
	if(this.m_DownloadProgressMax != 0)
	{
		var percent = (inCur * 100) / this.m_DownloadProgressMax;
	
		//CALLBACK
		HandleUpdateProgressBar(percent,downloadedBytes, totalBytes, hours, minutes, seconds);
	}
}
function
TUpdateInstanceCallback_UpdateMessage(inMessage)
{
	if (inMessage.length)
		this.m_MessageStore[this.m_MessageStore.length] = inMessage;
}

function
TUpdateInstanceCallback_NotifyUpdateFinished()
{
	gUIC_FinishedSrc = this.m_Src;
	gUIC_Successful = this.m_Successful;
	gUIC_UpdateCancelled = this.m_UpdateCancelled;
	gUIC_MessageStore = this.m_MessageStore;
	setTimeout("TUpdateInstanceCallback_STATICNotifyFinished();", 1000);
}

var gUIC_FinishedSrc = null;
var gUIC_Successful = false;
var gUIC_UpdateCancelled = false;
var gUIC_MessageStore = null;
function
TUpdateInstanceCallback_STATICNotifyFinished()
{
	gUpdateMgr.UpdateFinished(gUIC_FinishedSrc, gUIC_Successful, gUIC_MessageStore, gUIC_UpdateCancelled);
}
//========================================
function
WriteItemToConnectLog(statusCode, message, resultCode)
{
	try
	{

	}
	catch(e)
	{
	
	}
}
//========================================
function
TUpdateInstanceCallback_StatusCallback(statusCode, message, resultCode)
{
	//LOG
	if(statusCode != "UPDATE_STATUS")
	{
		top.DEBUGLOG("UPD_INSTANCE_MSG: sCode=" + statusCode + ",message=" + message + ",result=" + resultCode);
	}

	switch(statusCode)
	{
		case "INITIALIZE":
			this.SetStatusText("Initializing...");	//STRING
		break;
		
		// Control processing
		case "FINDING_UPDATE_FILE":
			this.SetStatusText("Locating update information...");	//STRING
		break;
		
		
		
		case "DOWNLOADING_UPDATE_FILE":
			this.SetStatusText("Downloading update information...");	//STRING
		break;
		
		case "UPDATE_FILE_DOWNLOADED":
		{
			WriteItemToConnectLog(statusCode, message, resultCode);
			this.SetStatusText("Update information received...");	//STRING
		}
		break;
		
		case "SENDING_RESULT_NOTIFICATION":
			this.SetStatusText("Sending result notification...");//STRING
		break;
		
		
		// control finalization
		case "NO_SECTIONS_PROCESSED":
			if (this.m_SectionsProcessed)
				this.m_UpdateCancelled = true; //Indicates some failure occurred.
			this.SetStatusText("Finished. No new updates.");//STRING

		break;
		
		case "SECTIONS_PROCESSED":
			this.m_Successful = true;
			this.SetStatusText("Finished. Update completed successfully.");	//STRING
			
		break;
		
		case "USER_CANCELED":
			//LAM - do we need to shut anything down here?
			this.SetStatusText("Finished. User cancelled.");	//STRING
			
			//boc -commented out.  even if the user cancels, we get a sections_processed message
			//this.NotifyUpdateFinished(); - 
		break;
		
		// errors
		case "UPDATE_DOWNLOAD_FAILED":
			this.SetStatusText("Update failed.");
			this.SetErrorText("Failed to retrieve update information. HTTP result=" + resultCode);//STRING
		break;
		
		case "CANT_LOAD_UPDATE_FILE":
			this.SetStatusText("Update failed.");
			this.SetErrorText("Could not load update file.");
		break;
		
		case "CANT_FIND_UPDATE_FILE":
			this.SetStatusText("Update failed.");
			this.SetErrorText("Can't find update file. Result=" + resultCode);//STRING
		break;
		
		case "UPDATE_PROCESS_ERROR":
			this.SetStatusText("Update failed.");
			this.SetErrorText("Update control processing error. " + message);
		break;
		
		case "NO_HANDLER_FOR_SECTION":
			this.SetStatusText("Update failed.");
			this.SetErrorText("No handler available for update section. Handler=" + message);	//STRING
		break;
		
		case "RESULT_NOTIFICATION_FAILED":
			this.SetStatusText("Update failed.");
			this.SetErrorText("Result notification failed. Result=" + resultCode);	//STRING
		break;
			
		// messages 
		case "UPDATE_MESSAGE":
			//THIS should display a message box
			this.DisplayUpdateMessage(message);
		break;
		
		case "RECONNECT_REQUESTED":
			//NOTE: to do
		break;
		
		case "UPDATE_STATUS":
			//NOTE: this displays internal strings.  Best to leave silent
	//this.SetStatusText(message);
		break;
		
		case "FINISHED":
			this.NotifyUpdateFinished();
		break;
		
		default:
		break;
	}

	

	//DEBUG
	var inStr = ("status=" + statusCode + " ,message=" + message + ", resultCode=" + resultCode);
	this.SetDebugStatus(inStr);
	
}
//========================================
function
TUpdateInstanceCallback_Prompt(promptStr, promptTitle, inAllowIgnore, nRemindMeLaterMaxMinutes)
{

	var retValue = true;
	
	//DEBUG
	this.SetDebugStatus("Prompt:" + promptStr);
	
	gPromptInProgress = true;
	
	// let the ui handler deal with the promp t
	// boc - 20060423 - note..if we have remind me later, and the user has returned minutes to wait, then mark the udpate as successful	
	retValue = HandleUpdatePrompt(promptStr, promptTitle, inAllowIgnore, nRemindMeLaterMaxMinutes);

	//boc - 20060423- note...changed so when user returns REMIND then it won't display an error if running "loud" mode.
	//					this is a bit different than if the user sez "NO" to update.
	gPromptInProgress = false;
	if (!retValue)
	{
		this.m_UpdateCancelled = true;
	}
	else
	{
		var strVal = retValue.toString();
		var searchRE = new RegExp("REMIND", "ig");
		var hasRemind = (strVal.search(searchRE) != -1) ? true : false;
		if(strVal == "DONTASK" || hasRemind)
		{
			this.m_Successful = true;
		}
	}

		
	this.m_SectionsProcessed = true;
	
	return retValue;
}
//========================================
function
TUpdateInstanceCallback_ShowDownloadStatus(show)
{
	//ignore
	this.SetDebugStatus("ShowDownloadStatus:" + show);
}
//========================================
function
TUpdateInstanceCallback_SetMessages(downloadingMessage, cancelMessage)
{

	if(downloadingMessage)
		this.m_DownloadMessage = downloadingMessage;
		
	if(cancelMessage)
		this.m_CancelMessage = cancelMessage;
}
//========================================
function
TUpdateInstanceCallback_BeginFileDownload()
{
	//DEBUG
	this.SetDebugStatus("Begin File Download");

	// called when file download starts
	this.SetStatusText("Downloading update package...");//STRING
}
//========================================
function
TUpdateInstanceCallback_SetDownloadProgressMax(inMax)
{
	//DEBUG
	this.SetDebugStatus("Set download progress max:" + inMax);

	this.m_DownloadProgressMax = inMax;
}
//========================================
function
TUpdateInstanceCallback_SetProgress(currentProgress, downloadedBytes, totalBytes, hours, minutes, seconds)
{
	//DEBUG
	this.SetDebugStatus("progress=" + currentProgress + ",bytes=" + downloadedBytes + ",total="+totalBytes);
	
	// update progress
	this.UpdateFileProgress(currentProgress,downloadedBytes, totalBytes, hours, minutes, seconds);
}
//========================================
function
TUpdateInstanceCallback_EndFileDownload(success)
{
	//DEBUG
	this.SetDebugStatus("End File Download:" + success);

	if(success)
	{
		this.SetStatusText("Update package download complete.");//STRING
	}
	else
	{
		this.SetStatusText("Update package download failed.");//STRING
		this.SetErrorText("Could not download update package.");//STRING
	}
}
//========================================
function
TUpdateInstanceCallback_BeginWait()
{
	//DEBUG
	this.SetDebugStatus("Begin wait");
	
	// starting execution
	this.SetStatusText("Extracting update contents.");//STRING
}
//========================================
function
TUpdateInstanceCallback_EndWait()
{
	//DEBUG
	this.SetDebugStatus("End wait");
	
	// Finished execution
	this.SetStatusText("Update contents extracted.");//STRING
}
//========================================
